function [Ome, de]=fKT(x,K)
% Przyklad 20.6
% x - sygnal analizowany
% K - zalozona liczba skladowych (tlumione sinusoidy o~wartosci rzeczywistej)
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl (na podstawie lpsvd.m [4])

M = 2*K;             % liczba skladowych zespolonych
N = length(x);       % liczba probek
L = floor(N*3/4);                      % przyjety rzad liniowej predykcji L = 3/4*N
Y = hankel( x(2:N-L+1), x(N-L+1:N) );  % macierz probek, zwiazana z predykcja "do tylu"
y = x(1:N-L)';       % wektor probek, zwiazana z predykcja "do tylu"
[U,S,V] = svd(Y,0);  % dekompozycja wzgledem wartosci szczegolnych
S = diag(S);
szum = mean(S(M+1:min([N-L,L])));            % przesuniecie - srednia energia szumu
b = V(:,1:M) * (diag(1./(S(1:M)-szum)) * (U(:,1:M)'*y)); % wspolczynniki predykcji "do tylu"
z = roots([-b(length(b):-1:1);1]); p=log(z); % pierwiastki wielomianu (20.73), ln()
p = p( find(real(p)<0) );                    % wewnatrz okregu jednostkowego
Om = imag(p); [Om indx] = sort( Om, 'descend' ); Ome = Om(1:K); % pulsacja katowa
de = -real(p(indx(1:K)));                    % wspolczynnik tlumienia
