function [Ome]=fPisarenko(y,K)
% Przyklad 20.8
% y - analizowana suma tlumionych sinusoid o wartosciach rzeczywistych w szumie
% K - zalozona liczba skladowych
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

N = length(y);                   % liczba probek sygnalu
L = 2*K;                         % rzad predykcji, liczba skladowych zespolonych
ryy=xcorr(y,'unbiased');         % do wyboru: 'unbiased', 'biased', 'coeff', 'none'
ryy = ryy(N:end);                % z powodu symetrii, bierzemy tylko polowe wyniku
Ryy = toeplitz( ryy(1:L+1) );    % zbudowanie macierzy Ryy
[V,D] = eig(Ryy);                % dekompozycja EVD tej macierzy
[Dmin indx] = min(diag(D));      % znalezienie najmniejszej wartosci wlasnej
a = V(:,indx).';                 % znalezienie skojarzonego z nia wektora wlasnego
z = roots(a); Om = imag(log(z)); % znalezienie pierwiastkow wielomianu
Om = sort( Om, 'descend' ); Ome = Om(1:K); % pulsacja (odrzucenie wartosci ujemnych)
