function [Ome, de]=fProny(x,K)
% Przyklad 20.3
% Metoda Prony'ego
% x - analizowany sygnal - suma tlumionych sinusoid rzeczywistych
% K - zalozona liczba skladowych
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

% DLA JEDNEJ SKLADOWEJ)
  if(K==1)
     N = length(x); X = toeplitz(x(2:N-1), x(2:-1:1)); x = x(3:N).';  % (20.48)
     a = X\x; % lub a = pinv(X)*x lub inv(X'*X)*X'*x;;                % (20.49c)
     p = log( roots( ([1; -a]) ));                                    % (20.43)
     Ome = abs(imag(p(1))); de = -real(p(1));                         % (20.44)
  end  
      
% DLA KILKU SKLADOWYCH
  if(K>1)
     N = length(x);
     P = 2*K;                                                         % rzad predykcji
     FirstCol = x(P:N-1); FirstRow = x(P:-1:1);                       %
     X = toeplitz( FirstCol, FirstRow ); x = x(P+1:N).';              % (X.48)(X.57)
     a = X\x;       % lub inv(X'*X)*X'*y; lub a = pinv(X)*y;          % (X.49c)(X.58)
     a1 = [1; -a];  % rozwiazanie Prony'ego
     p = roots( a1 );                                                 %(X.43)(X.59)
     p = log(p) ;                                                     % (X.44)
     Om = imag(p); [Om indx] = sort( Om, 'descend' ); Ome = Om(1:K);  % X.44)
     de = -real(p(indx(1:K)));
  end   