function [Ome, de]=fSTMB(x,K,NI)
% Przyklad 20.4
% x - analizowany sygnal
% K - liczba tlumionych sinusoid A*cos(Om*n+p).*exp(-d*n) w rownaniu (20.3)
% NI - liczba iteracji, dla NI=0 otrzymujemy metode Prony'ego
% Ome - estymata pulsacji (rd)
% de - estymata tlumienia
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

N = length(x);                             % liczba probek sygnalu
P = 2*K;                                   % rzad predykcji
FirstCol = x(P:N-1); FirstRow = x(P:-1:1); % pierwsza kolumna i rzad macierzy X (20.57)
X = toeplitz( FirstCol, FirstRow ); y = x(P+1:N).';   % macierz X w (20.57), (20.48)
a = X\y; % lub inv(X'*X)*X'*y; lub a = pinv(X)*y;     % rozwiazanie (20.58), (20.49c)
a1 = [1; -a];                              % inicjalizacja rozwiazaniem metoda Prony'ego
%a1 = [1; zeros(P,1) ];                    % prostsza inicjalizacja zerami
delta = zeros(1,N); delta(1)=1;            % impuls jednostkowy
while ( NI )
   v = filter(1, a1, x);                              % (20.51)
   u = filter(1, a1, delta);                          % (20.52)
   V = toeplitz( v, [ v(1) zeros(1,P) ] );            % (20.54) (20.63)
   U = toeplitz( u, [ u(1) zeros(1,P-1) ] );          % (20.54) (20.63)
   VU = [ V(1:N,:) U(1:N,:) ];                        % (20.54) (20.63)
   A = VU(:,2:end); d = VU(:,1);                      % (20.54) (20.63)
   c = A\d; % c = inv(A'*A)*A'*d; % c = pinv(A)*d;    % (20.55)
   a1 = [ 1; -c(1:P) ];                               % iteracyjna aktualizacja
   NI = NI-1;
end
p = roots( a1 );                           % (20.43)(20.59)
p = log(p);                                % (20.44)
Om = imag(p); [Om indx] = sort( Om, 'descend' ); Ome = Om(1:K); % (20.44)
de = -real(p(indx(1:K)));                  % (20.44)
