function [Ome, de] = flpCOR(x,K,nr)
% Przyklad 20.5
% x - analizowany sygnal
% K - liczba tlumionych sinusoid A*cos(Om*n+p).*exp(-d*n) w rownaniu (20.3)
% nr - numer metody
% Autor: Tomasz ZIELINSKI, tzielin@agh.edu.pl

N = length(x);            % liczba probek sygnalu
L = 2*K;                  % rzad predykcji, podwojona liczba skladowych rzeczywistych
M = N-L;                  % maksymalna liczba rownan
r = xcorr(x,'unbiased');  % funkcja korelacji: 'unbiased', 'biased', 'coeff', 'none'
r = r(N:end);             % tylko przesuniecia nieujemne w funkcji korelacji
if(nr == 1) % SREDNIO DOBRE, GRORSZE NIZ NR=2
   R1 = toeplitz( r(1:L) );              % macierz LxL
   r1 = r(2:L+1).'; % pause              % macierz Lx1
   a = R1\r1;
end
if(nr == 2) % ZAWSZE BARDZO DOBRE
   FirstCol = r(L:L+L-1); FirstRow = r(L:-1:1);
   R2 = toeplitz( FirstCol, FirstRow );  % macierz LxL
   r2 = r(L+1:L+L).'; % pause            % macierz Lx1
   a = R2\r2;
end
if(nr == 3) % DOBRE TYLKO BEZ TLUMIEN
   FirstCol = r(L:M+L-1); FirstRow = r(L:-1:1);
   R3 = toeplitz( FirstCol, FirstRow );  % macierz MxL
   r3 = r(L+1:L+M).'; % pause            % macierz Mx1
   a = R3\r3;
end
a1 = [1 -a.'];
p = roots( a1 ); p = log(p) ;            % (20.43)(20.44)(20.59)
Om = imag(p); [Om indx] = sort( Om, 'descend' ); Ome = Om(1:K);   % (20.44)
de = -real(p(indx(1:K)));
